#if !defined(AFX_BACKGROUNDDATA_H__8D2B843B_EC41_4AFD_AEF9_FD4DFAA58BAC__INCLUDED_)
#define AFX_BACKGROUNDDATA_H__8D2B843B_EC41_4AFD_AEF9_FD4DFAA58BAC__INCLUDED_

/*******************************************************************
 This file is part of Davves.

    Davves is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Davves is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Davves; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*********************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileList.h"
#include "SearchInfo.h"
#include "DavvesView.h"
#include "DavvesDoc.h"

#define DAV_SEARCH_STRING 1 
#define DAV_SEARCH_BROWSE 2
#define DAV_SEARCH_DIR 3
#define DAV_SEARCH_FILENAME 4

class CParseQuery
{
public:
	CParseQuery(LPCSTR strQuery); //init and do parsing
	unsigned char** getArray(); // you have destroy the array after use
	UINT getLengthOfArray(); 
private:
	bool parse();
	CStringList m_listTokens;
	CString m_strQuery;
};

class CBackgroundData  
{
private:
	// The four ways of searching
	void SearchString();
	void BrowseOffset();
	void BrowseDir();
	void BrowseFilename();

	int m_nOffset;
	void UpdateResult();
	bool findFilesInResult();
	bool findFiles();
	UINT m_nCurrentQuery;
	bool feedNextToken();
	unsigned char** m_arQuery;

	UINT m_nQueryCount;

	unsigned char* m_strSearchQuery;
	UINT m_nQueryLength;

	CSearchInfo m_SearchInfo;
	UINT m_nLastSearchId;
	CWinThread* m_thread;
	CDavvesDoc* m_pListDoc;
	CDavvesView* m_pListView;
	CFileList* m_pFileList;
	BYTE* m_dirMatch;

	CList<UINT, UINT> m_listResult; // The holy result!

public:
	void FilterSize();
	int getOffset();
	void DoSearch();
	void ParseQuery();
	void SetSearchInfo(CSearchInfo info);
	void setListView(CDavvesView *pView);
	void setListDoc(CDavvesDoc* pDoc);
	CBackgroundData(CWnd* pParent, CFileList* pFileList);	

	bool stopThread();
	bool startThread();

	virtual ~CBackgroundData();

	volatile BOOL m_bContinue;
	volatile BOOL m_bIsRunning;
	CWnd* m_pParent;
};

#endif // !defined(AFX_BACKGROUNDDATA_H__8D2B843B_EC41_4AFD_AEF9_FD4DFAA58BAC__INCLUDED_)
