 /*******************************************************************
 This file is part of Davves.

    Davves is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Davves is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Davves; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*********************************************************************/

// DavvesDoc.cpp : implementation of the CDavvesDoc class
//

#include "stdafx.h"
#include "Davves.h"

#include "DavvesDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDavvesDoc

IMPLEMENT_DYNCREATE(CDavvesDoc, CDocument)

BEGIN_MESSAGE_MAP(CDavvesDoc, CDocument)
	//{{AFX_MSG_MAP(CDavvesDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDavvesDoc construction/destruction

CDavvesDoc::CDavvesDoc()
{
	m_pSearchResult = NULL;
}

CDavvesDoc::~CDavvesDoc()
{
	Free();
}

BOOL CDavvesDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDavvesDoc serialization

void CDavvesDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDavvesDoc diagnostics

#ifdef _DEBUG
void CDavvesDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDavvesDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDavvesDoc commands

void CDavvesDoc::Sort(int nCol, int nOrder)
{
	if (m_pSearchResult)
		m_pSearchResult->Sort(nCol,nOrder);
}

bool CDavvesDoc::Free()
{
	if (m_pSearchResult)
	{
		m_pSearchResult->Free();
		delete m_pSearchResult;
		m_pSearchResult = NULL;
	}
	return true;
}

void CDavvesDoc::Allocate(int nMaxHits)
{
	ASSERT (!m_pSearchResult);
	m_pSearchResult = new CSearchResult(nMaxHits);
}

int CDavvesDoc::GetItemOfStr(LPCTSTR str,int nStart)
{
	char* buf = new char[strlen(str)+1];
	strcpy(buf,str);
	return m_pSearchResult->GetItemOfStr(buf,nStart);
	delete[] buf;
}
