#if !defined(AFX_DAVVESVIEW_H__F864AB4C_EB96_4F5B_A83F_A4DC23ED05B1__INCLUDED_)
#define AFX_DAVVESVIEW_H__F864AB4C_EB96_4F5B_A83F_A4DC23ED05B1__INCLUDED_

 /*******************************************************************
 This file is part of Davves.

    Davves is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Davves is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Davves; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*********************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DAV_VIEW_FILENAME 0
#define DAV_VIEW_FILESIZE 1
#define DAV_VIEW_SHARE 2
#define DAV_VIEW_PING 3
#define DAV_VIEW_DISTANCE 4
#define DAV_VIEW_ACCESS 5

#include "DavvesDoc.h"

typedef CMap<int, int, int, int> CIntMap;

class CDavvesView : public CListView
{
protected: // create from serialization only
	CDavvesView();
	DECLARE_DYNCREATE(CDavvesView)

// Attributes
public:
	CDavvesDoc* GetDocument();
	int m_nSortedCol; 
	int m_nSortOrder;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDavvesView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdateImageList();
	void SetNoItemsText(CString str);
	afx_msg void OnCustomdraw( NMHDR* pNMHDR, LRESULT* pResult );
	void Update();
	void OnHeaderClicked(NMHDR* pNMHDR, LRESULT* pResult);
	BOOL ResetContent();
	virtual ~CDavvesView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDavvesView)
	afx_msg void OnGetdispinfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnListFocus();
	afx_msg void OnOdfinditem(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int m_nSelectionCount;
	int* m_pSelection;
	unsigned char* m_strNoItems;
	CImageList* m_ImageList;
	CFont m_font;
};

#ifndef _DEBUG  // debug version in DavvesView.cpp
inline CDavvesDoc* CDavvesView::GetDocument()
   { return (CDavvesDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DAVVESVIEW_H__F864AB4C_EB96_4F5B_A83F_A4DC23ED05B1__INCLUDED_)
