// DownloadControl.h: interface for the CDownloadControl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DOWNLOADCONTROL_H__00A2F888_9C8C_4DFF_B7CE_87ED62E13B84__INCLUDED_)
#define AFX_DOWNLOADCONTROL_H__00A2F888_9C8C_4DFF_B7CE_87ED62E13B84__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IPCReadWriteLock.h"
#include "DownloadGroup.h"
#include "WaitInfo.h"

#define DAV_IPC_BLOCK_GROUP 1

class CDownloadControl
{
public:
	CWnd* m_pParent;
	bool m_bDLProcRunning;
	void StartDownload();
	void UpdateDownload();
	bool Init();
	bool Close();

	void AddGroup(CDownloadGroup* group);
	void Download();

	CDownloadControl();
	virtual ~CDownloadControl();
private:

	CDownloadGroups m_lsGroups;

	// IPC stuff
    CIPCReadWriteLock* m_pLock;
    // memory mapping file 
    HANDLE m_hFileMapping;      // memory mapped file
    BYTE* m_pViewOfFile;       // view of file
	BYTE* m_pViewBeginning;

	// Download stuff
	CWaitInfo requestor;
};

#endif // !defined(AFX_DOWNLOADCONTROL_H__00A2F888_9C8C_4DFF_B7CE_87ED62E13B84__INCLUDED_)
