 /*******************************************************************
 This file is part of Davves.

    Davves is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Davves is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Davves; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*********************************************************************/

// DownloadGroup.cpp: implementation of the CDownloadGroup class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "davves.h"
#include "DownloadGroup.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDownloadGroup::CDownloadGroup()
{
}

CDownloadGroup::~CDownloadGroup()
{
}

CDownloadGroups::CDownloadGroups()
{
}

CDownloadGroups::~CDownloadGroups()
{
}

//////////////////////////////////////////////////////////////////////
// Getters
//////////////////////////////////////////////////////////////////////

CDownloadFile* CDownloadGroup::GetNextFile()
{
	if (m_posNextFile)
		return m_lsFiles.GetNext(m_posNextFile);
	else 
		return NULL;
}

int CDownloadGroup::GetShareCount()
{
	return m_lsFiles.GetCount();
}

//////////////////////////////////////////////////////////////////////
// Setters
//////////////////////////////////////////////////////////////////////

void CDownloadGroup::AddFile(CDownloadFile* file)
{
	m_lsFiles.AddTail(file);

	// Was this the first time?
	//if (m_listFiles.GetCount() == 1)
	m_posNextFile = m_lsFiles.GetHeadPosition();
}

//////////////////////////////////////////////////////////////////////
// Datamaking
//////////////////////////////////////////////////////////////////////
	
void CDownloadGroup::PrepareData()
{
	BYTE* pData;
	m_nDataSize = 0;

	// Find out size och data ,.... Just making sure

	m_nDataSize += 1; // For file count
	
	POSITION pos;
	CDownloadFile* file;

	pos = m_lsFiles.GetHeadPosition();
	while (pos)
	{	
		file = m_lsFiles.GetNext(pos);
		file->PrepareData();
		m_nDataSize += file->GetDataSize();
	}
	
	m_pData = new BYTE[m_nDataSize];
	pData = m_pData;

	*pData = (BYTE)m_lsFiles.GetCount();
	pData++;

	pos = m_lsFiles.GetHeadPosition();
	while (pos)
	{	
		file = m_lsFiles.GetNext(pos);
		memcpy(pData,file->GetData(),file->GetDataSize());
		pData+=file->GetDataSize();
		file->FreeData();
	}
}

int CDownloadGroup::GetDataSize()
{
	return m_nDataSize;	
}

BYTE* CDownloadGroup::GetData()
{
	return m_pData;
}

void CDownloadGroup::FreeData()
{
	delete[] m_pData;
}
