#if !defined(AFX_DOWNLOADGROUP_H__A8617C3F_C6FF_49A5_9D68_DE723F4C3821__INCLUDED_)
#define AFX_DOWNLOADGROUP_H__A8617C3F_C6FF_49A5_9D68_DE723F4C3821__INCLUDED_

 /*******************************************************************
 This file is part of Davves.

    Davves is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Davves is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Davves; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*********************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>
#include "filelist.h"

typedef CTypedPtrList<CPtrList,CDownloadFile*> CDownloadFiles;

//////////////////////////////////////////////////////////////////////////////
//
// En grupp av filer
//
// Den hr klassen r tnkt att anvndas till att skickas till CDownloadControl
// som parsar den och gr vad den vill med den
// 
// Man gr AddFile p alla sina filer. Lgger till gruppen med 
// CDownloadControl::AddGroup()
// Kallar p CDownloadControl::Download()
// CDownloadFile objekten mste existera under hela denna tiden!
// Efter detta kan de tas bort

class CDownloadGroup  
{
private:
	// For Datamaking
	BYTE* m_pData;
	int m_nDataSize;

	POSITION m_posNextFile;				// Locator in list
	CDownloadFiles m_lsFiles;			// List of pointers to files
public:
	CDownloadGroup();
	virtual ~CDownloadGroup();
	
	// Getters
	int GetShareCount();
	CDownloadFile* GetNextFile(); // Removes head and returns it

	// Setters
	void AddFile(CDownloadFile* file); // Add file to tail

	// Datamaking 
	void PrepareData();
	int GetDataSize();
	BYTE* GetData();
	void FreeData();
};

//////////////////////////////////////////////////////////////////////////////
//
// En lista av grupper
//
// Den hr klassen r tnkt att anvndas av CDownloadControl
// 

class CDownloadGroups : public CTypedPtrList<CPtrList,CDownloadGroup*>
{
public:
	CDownloadGroups();
	~CDownloadGroups();
	BOOL m_bAutoDelete;
};


#endif // !defined(AFX_DOWNLOADGROUP_H__A8617C3F_C6FF_49A5_9D68_DE723F4C3821__INCLUDED_)
