// History.cpp: implementation of the CHistory class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "davves.h"
#include "History.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHistory::CHistory()
{
	m_posCurrent = m_lsHistory.GetTailPosition();
}

CHistory::~CHistory()
{

}

void CHistory::AddSearch(CSearchInfo info)
{
	// Snaps branches
	while (CanMoveForward())
	{
		m_lsHistory.RemoveTail();
	}
	
	m_lsHistory.AddTail(info);
	m_posCurrent = m_lsHistory.GetTailPosition();
}

CSearchInfo CHistory::MoveBack()
{
	m_lsHistory.GetPrev(m_posCurrent);
	return m_lsHistory.GetAt(m_posCurrent);
}

CSearchInfo CHistory::MoveForward()
{
	m_lsHistory.GetNext(m_posCurrent);
	return m_lsHistory.GetAt(m_posCurrent);
}
	
bool CHistory::CanMoveForward()
{
	return (m_posCurrent != m_lsHistory.GetTailPosition());
}

bool CHistory::CanMoveBack()
{
	return (m_posCurrent != m_lsHistory.GetHeadPosition());
}

CSearchInfo CHistory::GetCurrent()
{
	return m_lsHistory.GetAt(m_posCurrent);
}

void CHistory::SavePosition(int nItem)
{
	m_lsHistory.GetAt(m_posCurrent).m_nSelectedItem = nItem;
}
