#if !defined(AFX_MAINFRM_H__6CD16DBB_D7DD_45F5_A959_EC70E290279C__INCLUDED_)
#define AFX_MAINFRM_H__6CD16DBB_D7DD_45F5_A959_EC70E290279C__INCLUDED_

#include "BackgroundData.h"	// Added by ClassView
#include "FileList.h"	// Added by ClassView

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

 /*******************************************************************
 This file is part of Davves.

    Davves is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Davves is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Davves; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*********************************************************************/


#include "SearchBar.h"
#include "OptionsBar.h"
#include "BackgroundData.h"	// Added by ClassView
#include "PingThread.h"	// Added by ClassView
#include "DirDialog.h"
#include "History.h"
#include "DownloadControl.h"
#include "WaitInfo.h"
#include "Settings.h"

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	void StopBackgroundData();
	void InitBackgroundData();
	void OnWebHelp();
	afx_msg void OnUpdateListCreatedIndicator(CCmdUI *pCmdUI);
	afx_msg void OnUpdateListDataIndicator(CCmdUI *pCmdUI);
	void OnSearchQueryButton();
	CImageList* GetImageList();
	void InitImageList();
	BOOL GetText(UINT id, NMHDR *pNMHDR, LRESULT *pResult);
	void OnBackButton();
	void OnNextButton();
	CPingThread m_PingThread;
	bool m_bHaveList;
	CString m_strDownloadDir;
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CReBar      m_wndReBar;
	CSearchBar  m_wndDlgBar;
	COptionsBar	m_wndOptBar;

// Generated message map functions
protected:
	LRESULT OnCompletion(WPARAM wParam, LPARAM lParam);
	void OnSearchCommand(WPARAM wParam, LPARAM lParam);
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSearchButton();
	afx_msg void OnClose();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnItemAddtoqueue();
	afx_msg void OnItemOpendirectory();
	afx_msg void OnItemExecute();
	afx_msg void OnItemPing();
	afx_msg void OnListUpdate();
	afx_msg void OnUpdateNextButton(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBackButton(CCmdUI* pCmdUI);
	afx_msg void OnItemAddasseparategroups();
	afx_msg void OnHelpLicence();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnViewDownload();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnFileOptions();
	afx_msg void OnItemListdirectory();
	afx_msg void OnUp();
	afx_msg void OnUpdateUp(CCmdUI* pCmdUI);
	afx_msg void OnDown();
	afx_msg void OnUpdateDown(CCmdUI* pCmdUI);
	afx_msg void OnToolsCheckupdates();
	afx_msg void OnItemCopypath();
	afx_msg void OnHelpCheckversion();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	const char* m_strNetworkFilename;
	CImageList m_ImageList;
	bool m_bUp;
	bool m_bDown;
	bool m_bPrev;
	bool m_bNext;
	CFont m_fontVerdana;
	CFileList m_fileList;
	CString strFilename, strDirname;

	CBackgroundData* m_pBackgroundData;
	CHistory m_History;
	CDownloadControl m_Download;
	CSettings m_Settings;

	// Internal procs
	bool CheckStatus();
	void StartSearch(CSearchInfo info);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__6CD16DBB_D7DD_45F5_A959_EC70E290279C__INCLUDED_)
