 /*******************************************************************
 This file is part of Davves.

    Davves is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Davves is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Davves; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*********************************************************************/

// SearchBar.cpp : implementation file
//

#include "stdafx.h"
#include "Davves.h"
#include "SearchBar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSearchBar dialog


CSearchBar::CSearchBar(CWnd* pParent /*=NULL*/)
	: CInitDialogBar()
{
	//{{AFX_DATA_INIT(CSearchBar)
	//}}AFX_DATA_INIT
}

void CSearchBar::DoDataExchange(CDataExchange* pDX)
{
	//{{AFX_DATA_MAP(CSearchBar)
	DDX_Control(pDX, IDC_QUERY_EDIT, m_ctrlQueryEdit);
	DDX_Text(pDX, IDC_QUERY_EDIT, m_strQuery);
	DDV_MaxChars(pDX, m_strQuery, 30);
	DDX_Control(pDX,IDC_SEARCH_BUTTON, m_ctrlSearchButton);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSearchBar, CInitDialogBar)
	//{{AFX_MSG_MAP(CSearchBar)
	//ON_NOTIFY_EX( TTN_NEEDTEXT, 0, GetText)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CSearchBar::OnInitDialogBar()
{
	CInitDialogBar::OnInitDialogBar();

	UpdateData(FALSE);
	return true;
}

BOOL CSearchBar::GetText(UINT id, NMHDR *pNMHDR, LRESULT *pResult)
{
	TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);
        if(nID)
        {
            pTTT->lpszText = MAKEINTRESOURCE(nID);
            pTTT->hinst = AfxGetResourceHandle();
            return(TRUE);
        }
    }
    return(FALSE);

}
