// Settings.cpp: implementation of the CSettings class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "davves.h"
#include "Settings.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSettings::CSettings()
{
	UpdateFromReg();
}

CSettings::~CSettings()
{
	WriteToReg();
}

void CSettings::WriteToReg()
{
	CWinApp *app = AfxGetApp();
	app->WriteProfileString("Settings","DefaultDownloadPath",m_strDefaultDownloadPath);
	app->WriteProfileInt("Settings","AskBeforeDelete",m_bAskBeforeDelete);
	app->WriteProfileInt("Settings","AskForFilename",m_bAskForFilename);
	app->WriteProfileInt("Settings","FilemngrHeigth",m_nFilemngrHeigth);
	app->WriteProfileInt("Settings","DownloadHeigth",m_nDownloadHeigth);
	app->WriteProfileInt("Settings","LogHeigth",m_nLogHeigth);
	app->WriteProfileInt("Settings","MaxDownloads",m_nMaxDownloadCount);
}

void CSettings::UpdateFromReg()
{
	CWinApp *app = AfxGetApp();

	m_strDefaultDownloadPath = app->GetProfileString("Settings","DefaultDownloadPath","c:\\");
	m_bAskBeforeDelete = app->GetProfileInt("Settings","AskBeforeDelete",1);
	m_bAskForFilename = app->GetProfileInt("Settings","AskForFilename",0);
	m_nMaxDownloadCount = app->GetProfileInt("Settings","MaxDownloads",3);

	m_nFilemngrHeigth = app->GetProfileInt("Settings","FilemngrHeigth",150);
	m_nDownloadHeigth = app->GetProfileInt("Settings","DownloadHeigth",150);
	m_nLogHeigth = app->GetProfileInt("Settings","LogHeigth",150);
}
