// ControlFile.h: interface for the CControlFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONTROLFILE_H__6D885FED_64E1_40AF_A635_7A65052D4554__INCLUDED_)
#define AFX_CONTROLFILE_H__6D885FED_64E1_40AF_A635_7A65052D4554__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IPCReadWriteLock.h"
#include "DownloadGroup.h"

#define DAV_BLOCK_IPC_GROUP 1
#define DAV_BLOCK_DISK_GROUP 2

#define DAV_IPC 0
#define DAV_DISK 1

typedef CMap<int, int, int, int> CIntMap;

class CControlFile  
{
private:
	bool m_bLoaded;
	CDownloadGroups m_lsGroups;
	POSITION m_posNext;

    HANDLE m_hIPCMap;  

	BYTE* m_pViewOfIPC;

	// IPC sync.
    CIPCReadWriteLock* m_pLock;

	void LoadBlocks(BYTE* view);
	void LoadBlockGroup(BYTE* view, BOOL bReadGroupData);

	void WriteBlocks(BYTE* view);
	int PrepareData();

public:
	BOOL Save();
	void DeleteGroup(CDownloadGroup *group);
	CControlFile();
	virtual ~CControlFile();

	bool Load();
	void Unload();
	void LoadFromIPC();

	// Publics
	void AddGroup(CDownloadGroup* group);
	
	CDownloadGroup* GetNext();
	void Rewind();
};

#endif // !defined(AFX_CONTROLFILE_H__6D885FED_64E1_40AF_A635_7A65052D4554__INCLUDED_)
