// DownloadDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Download.h"
#include "DownloadDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDownloadDlg dialog

CDownloadDlg::CDownloadDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CDownloadDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDownloadDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nNextID = 0;
}

void CDownloadDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDownloadDlg)
	DDX_Control(pDX, IDC_DOWNLOAD_LIST, m_ctrlDownloadList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDownloadDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CDownloadDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDownloadDlg message handlers

BOOL CDownloadDlg::OnInitDialog()
{
	CResizableDialog::OnInitDialog();

	m_ctrlDownloadList.SetExtendedStyle(LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_HEADERDRAGDROP);
	
	AddAnchor(IDC_DOWNLOAD_LIST,TOP_LEFT ,BOTTOM_RIGHT);

	CRect rect;
	m_ctrlDownloadList.GetWindowRect(rect);
	int nWidth = rect.Width();

	CWinApp* app = AfxGetApp();
	int nNameWidth = app->GetProfileInt("Download","NameWidth",(int)(nWidth*0.50));
	int nSizeWidth = app->GetProfileInt("Download","SizeWidth",(int)(nWidth*0.12));
	int nSpeedWidth = app->GetProfileInt("Download","SpeedWidth",(int)(nWidth*0.12));
	int nDoneWidth = app->GetProfileInt("Download","DoneWidth",(int)(nWidth*0.12));
	int nTimeWidth = app->GetProfileInt("Download","TimeWidth",(int)(nWidth*0.14));

	m_ctrlDownloadList.InsertColumn(DL_NAME,"Name",LVCFMT_LEFT,nNameWidth);
	m_ctrlDownloadList.InsertColumn(DL_SIZE,"Size",LVCFMT_LEFT,nSizeWidth);
	m_ctrlDownloadList.InsertColumn(DL_SPEED,"Speed",LVCFMT_LEFT,nSpeedWidth);
	m_ctrlDownloadList.InsertColumn(DL_DONE,"Done",LVCFMT_LEFT,nDoneWidth);
	m_ctrlDownloadList.InsertColumn(DL_TIME,"Time left",LVCFMT_LEFT,nTimeWidth);

	// Set heigth
	SetWindowPos(&wndTop,0,0,nWidth,m_pSettings->m_nDownloadHeigth,SWP_NOACTIVATE|SWP_NOMOVE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDownloadDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CResizableDialog::OnPaint();
	}
}

HCURSOR CDownloadDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDownloadDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	switch (nID)
	{
	case SC_CLOSE:
		ShowWindow(FALSE);
		break;
	default:
		CResizableDialog::OnSysCommand(nID, lParam);
		break;
	}
}

void CDownloadDlg::OnDestroy() 
{
	CResizableDialog::OnDestroy();
	
	CWinApp* app = AfxGetApp();
	app->WriteProfileInt("Download","NameWidth",m_ctrlDownloadList.GetColumnWidth(DL_NAME));
	app->WriteProfileInt("Download","SizeWidth",m_ctrlDownloadList.GetColumnWidth(DL_SIZE));
	app->WriteProfileInt("Download","SpeedWidth",m_ctrlDownloadList.GetColumnWidth(DL_SPEED));
	app->WriteProfileInt("Download","DoneWidth",m_ctrlDownloadList.GetColumnWidth(DL_DONE));
	app->WriteProfileInt("Download","TimeWidth",m_ctrlDownloadList.GetColumnWidth(DL_TIME));	

	CRect rect;
	GetWindowRect(rect);
	m_pSettings->m_nDownloadHeigth = rect.Height();
}

void CDownloadDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CRect rect;
	m_ctrlDownloadList.GetWindowRect(rect);
	CFileStatus stat;

	if (rect.PtInRect(point)) // it's for the list ctrl
	{
		CMenu popupMenus;
		if (popupMenus.LoadMenu(IDR_POPUP_MENU))
		{
			POSITION pos = m_ctrlDownloadList.GetFirstSelectedItemPosition();
			CMenu* pPopup;
			if (pos == NULL)
			{
								//pPopup = popupMenus.GetSubMenu(1);
			}
			else
			{
				pPopup = popupMenus.GetSubMenu(1);
				pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON,point.x,point.y,this,NULL);	
			}
		}
	}	
}

//////////////////////////////////////////////////////////////////////////////
// The Good stuff

int CDownloadDlg::AddGroup(CDownloadGroup* group) 
{
	int nIdx = m_ctrlDownloadList.InsertItem(m_nNextID,group->GetName(),0);
	m_ctrlDownloadList.SetItemData(nIdx,(LPARAM)group);
	m_nNextID++;

	UpdateGroup(group);
	return nIdx;
}

BOOL CDownloadDlg::UpdateGroup(CDownloadGroup *group) 
{
	int nIdx = FindItem(group);
	if (nIdx != -1)
	{
		m_ctrlDownloadList.SetItemText(nIdx,DL_NAME,group->GetName());
		m_ctrlDownloadList.SetItemText(nIdx,DL_SIZE,group->GetFilesizes());
		m_ctrlDownloadList.SetItemText(nIdx,DL_SPEED,"0 KB/s");
		m_ctrlDownloadList.SetItemText(nIdx,DL_DONE,"0 %");
		m_ctrlDownloadList.SetItemText(nIdx,DL_TIME,"[unknown]");
		return TRUE;
	}
	else
		return FALSE;
}

BOOL CDownloadDlg::UpdateGroup(CGroupStatus* status) 
{
	int nIdx = FindItem(status->m_pGroup);
	if (nIdx != -1)
	{
		char strProcent[25];
		char strStatus[255];
		char strStat[55];
		char strSpeed[20];

		switch (status->m_nStatus)
		{
		case DDS_DOWNLOADING:	
			strcpy(strStat,"Downloading");
			break;
		case DDS_OPENING:
			strcpy(strStat,"Opening");
			break;
		case DDS_COMPLETE:
			strcpy(strStat,"Completed");		
			break;
		case DDS_ABORTED:
			strcpy(strStat,"Aborted");		
			break;
		default:
			sprintf(strStat,"Unknown [%d]",status->m_nStatus);
			TRACE("%s\n",strStat);
		}

		sprintf(strStatus,"Status: %s",strStat);
		sprintf(strProcent,"%d%%",status->m_nProcent);
		sprintf(strSpeed,"%.0f KB/s",status->m_dSpeed);

		m_ctrlDownloadList.SetItemText(nIdx,DL_SPEED,strSpeed);
		m_ctrlDownloadList.SetItemText(nIdx,DL_DONE,strProcent);
		m_ctrlDownloadList.SetItemText(nIdx,DL_TIME,"[unknown]");
		return TRUE;
	}
	else
		return FALSE;
}


BOOL CDownloadDlg::RemoveGroup(CDownloadGroup *group) 
{
	int nIdx = FindItem(group);
	if (nIdx != -1)
	{
		return m_ctrlDownloadList.DeleteItem(nIdx);
	}
	else
		return FALSE;
}

BOOL CDownloadDlg::RemoveGroup(CGroupStatus* status) 
{
	int nIdx = FindItem(status->m_pGroup);
	if (nIdx != -1)
	{
		return m_ctrlDownloadList.DeleteItem(nIdx);
	}
	else
		return FALSE;
}

CDownloadGroup* CDownloadDlg::GetSelectedGroup() 
{
	POSITION pos = m_ctrlDownloadList.GetFirstSelectedItemPosition();
	if (pos)
	{
		int nListIdx = m_ctrlDownloadList.GetNextSelectedItem(pos);
		return (CDownloadGroup *)m_ctrlDownloadList.GetItemData(nListIdx);
	}
	else
		return NULL;
}

int CDownloadDlg::FindItem(CDownloadGroup *group)
{
	LVFINDINFO info;
	info.flags = LVFI_PARAM;
	info.lParam = (LPARAM)group;
	return m_ctrlDownloadList.FindItem(&info);
}
