 /*******************************************************************
 This file is part of Davves.

    Davves is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Davves is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Davves; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*********************************************************************/

//////////////////////////////////////////////////////////////////////
//
// DownloadQueuedFile.cpp: implementation of the CDownloadQueuedFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Download.h"
#include "DownloadQueuedFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDownloadQueuedFile::CDownloadQueuedFile()
{
}

CDownloadQueuedFile::~CDownloadQueuedFile()
{
}
//////////////////////////////////////////////////////////////////////
// Getters
//////////////////////////////////////////////////////////////////////

LPCSTR CDownloadQueuedFile::GetFilename()
{
	return m_strFilename;
}

LPCSTR CDownloadQueuedFile::GetDirname()
{
	return m_strDirname;
}

LPCSTR CDownloadQueuedFile::GetIP()
{
	return m_strIP;
}

int CDownloadQueuedFile::GetPing()
{
	return m_nPing;
}

int CDownloadQueuedFile::GetDistance()
{
	return m_nDistance;
}

int CDownloadQueuedFile::GetId()
{
	return m_nId;
}

int CDownloadQueuedFile::GetFilesize()
{
	return m_nFilesize;
}

BYTE CDownloadQueuedFile::GetAccess()
{
	return m_nAccess;
}

//////////////////////////////////////////////////////////////////////
// Setters
//////////////////////////////////////////////////////////////////////

void CDownloadQueuedFile::SetPing(int nPing)
{
	m_nPing = nPing;
}

void CDownloadQueuedFile::SetDistance(int nDistance)
{
	m_nDistance = nDistance;
}

void CDownloadQueuedFile::SetAccess(BYTE nAccess)
{
	m_nAccess = nAccess;
}

void CDownloadQueuedFile::SetId(int nId)
{
	m_nId = nId;
}

void CDownloadQueuedFile::SetFilename(LPCSTR strFilename)
{
	strcpy(m_strFilename,strFilename);
}

void CDownloadQueuedFile::SetDirname(LPCSTR strDirname)
{
	strcpy(m_strDirname,strDirname);
}

void CDownloadQueuedFile::SetFilesize(int nFilesize)
{
	m_nFilesize = nFilesize;
}

void CDownloadQueuedFile::SetIP(LPCSTR strIP)
{
	strcpy(m_strIP, strIP);
}


//////////////////////////////////////////////////////////////////////
// Datamaking for CDownloadQueuedFile
//////////////////////////////////////////////////////////////////////
	
void CDownloadQueuedFile::PrepareData()
{
	BYTE* pData;
	m_nDataSize = 0;

	// Find out size och data ,.... 
	int nFilenameLength = strlen(m_strFilename) + 1;
	int nDirnameLength = strlen(m_strDirname) + 1;

	m_nDataSize += 30; // For static info
	m_nDataSize += nFilenameLength;
	m_nDataSize += nDirnameLength;

	m_pData = new BYTE[m_nDataSize];
	pData = m_pData;
	
	// Write acc. spec
	// FileId
	*(int *)pData = m_nId;
	pData+=4;

	// Filenamelength
	*pData = (BYTE)nFilenameLength;
	pData++;

	// Dirnameslength
	
	*pData = (BYTE)nDirnameLength;
	pData++;

	// Ping
	*(WORD *)pData = (WORD)m_nPing;
	pData+=2;

	*pData = m_nDistance;
	pData++;

	*pData = m_nAccess;
	pData++;

	// Filstorlek
	*(int *)pData = m_nFilesize;
	pData+=4;

	// IP Adress
	strcpy((char *)pData,m_strIP);
	pData+=16;

	// Filename
	strcpy((char *)pData,m_strFilename);
	pData+=nFilenameLength;

	// Dirname
	strcpy((char *)pData,m_strDirname);
	pData+=nDirnameLength;

}

int CDownloadQueuedFile::GetDataSize()
{
	return m_nDataSize;	
}

BYTE* CDownloadQueuedFile::GetData()
{
	return m_pData;
}

void CDownloadQueuedFile::FreeData()
{
	delete[] m_pData;
}
