// FilemngrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "download.h"
#include "FilemngrDlg.h"
#include "GroupEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilemngrDlg dialog


CFilemngrDlg::CFilemngrDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CFilemngrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFilemngrDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_nNextListIdx = 0;
}


void CFilemngrDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilemngrDlg)
	DDX_Control(pDX, IDC_FILES_LIST, m_ctrlFiles);
	//}}AFX_DATA_MAP
}


BOOL CFilemngrDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message >= WM_KEYFIRST && 
		pMsg->message <= WM_KEYLAST) {
		// translate using accelerator table
		ASSERT(m_hAccel);
		return ::TranslateAccelerator(m_hWnd, m_hAccel, 
			pMsg);
	}
	return CDialog::PreTranslateMessage(pMsg);
}

 


BEGIN_MESSAGE_MAP(CFilemngrDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CFilemngrDlg)
	ON_WM_DESTROY()
	ON_WM_SYSCOMMAND()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_POPUP_DELETE_FROMLISTONLY, OnPopupDeleteFromlistonly)
	ON_COMMAND(ID_POPUP_DELETE_FROMDISK, OnPopupDeleteFromdisk)
	ON_COMMAND(ID_FILEMNGR_EXECUTE_ENQUEUE, OnFilemngrExecuteEnqueue)
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILEMNGR_EDIT, OnFilemngrEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilemngrDlg message handlers

BOOL CFilemngrDlg::OnInitDialog() 
{
	CResizableDialog::OnInitDialog();
	
	// Accelerator
	m_hAccel = ::LoadAccelerators(AfxGetInstanceHandle(),
		MAKEINTRESOURCE(IDR_FILEMNGR));
	ASSERT(m_hAccel);
	
	AddAnchor(IDC_FILES_LIST,TOP_LEFT,BOTTOM_RIGHT);	
	
	m_ctrlFiles.SetExtendedStyle(LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES| LVS_EX_HEADERDRAGDROP);
	CRect rect;
	m_ctrlFiles.GetWindowRect(rect);
	int nWidth = rect.Width();
	
	CWinApp* app = AfxGetApp();
	int nNameWidth = app->GetProfileInt("Filemngr","NameWidth",(int)(nWidth*0.35));
	int nActionWidth = app->GetProfileInt("Filemngr","ActionWidth",(int)(nWidth*0.05));
	int nStatusWidth = app->GetProfileInt("Filemngr","StatusWidth",(int)(nWidth*0.35));
	int nSizeWidth = app->GetProfileInt("Filemngr","SizeWidth",(int)(nWidth*0.15));
	int nDoneWidth = app->GetProfileInt("Filemngr","DoneWidth",(int)(nWidth*0.10));

	m_ctrlFiles.InsertColumn(FM_NAME,"Name",LVCFMT_LEFT,nNameWidth);
	m_ctrlFiles.InsertColumn(FM_ACTION," ",LVCFMT_LEFT,nActionWidth);
	m_ctrlFiles.InsertColumn(FM_STATUS,"Status",LVCFMT_LEFT,nStatusWidth);
	m_ctrlFiles.InsertColumn(FM_SIZE,"Size",LVCFMT_LEFT,nSizeWidth);
	m_ctrlFiles.InsertColumn(FM_DONE,"Done",LVCFMT_LEFT,nDoneWidth);

	// Get some files

	if (!m_fileControl.Load())
	{
		PostQuitMessage(1);
		return FALSE;
	}
	UpdateList();

	// Set heigth
	SetWindowPos(&wndTop,0,0,nWidth,m_pSettings->m_nFilemngrHeigth,SWP_NOACTIVATE|SWP_NOMOVE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CFilemngrDlg::OnDestroy() 
{
	CResizableDialog::OnDestroy();
	
	CWinApp* app = AfxGetApp();
	app->WriteProfileInt("Filemngr","NameWidth",m_ctrlFiles.GetColumnWidth(FM_NAME));
	app->WriteProfileInt("Filemngr","ActionWidth",m_ctrlFiles.GetColumnWidth(FM_ACTION));
	app->WriteProfileInt("Filemngr","StatusWidth",m_ctrlFiles.GetColumnWidth(FM_STATUS));
	app->WriteProfileInt("Filemngr","SizeWidth",m_ctrlFiles.GetColumnWidth(FM_SIZE));
	app->WriteProfileInt("Filemngr","DoneWidth",m_ctrlFiles.GetColumnWidth(FM_DONE));	

	CRect rect;
	GetWindowRect(rect);
	m_pSettings->m_nFilemngrHeigth = rect.Height();
	
	// Write files to disk and unload stuff
	m_fileControl.Unload();
}

void CFilemngrDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	switch (nID)
	{
	case SC_CLOSE:
		ShowWindow(FALSE);
		break;
	default:
		CResizableDialog::OnSysCommand(nID, lParam);
		break;
	}	
	CResizableDialog::OnSysCommand(nID, lParam);
}

/////////////////////////////////////////////////////////////////////////////
// Query user for info about group
/////////////////////////////////////////////////////////////////////////////
bool CFilemngrDlg::UpdateGroupData(CDownloadGroup* group)
{
	if (m_pSettings->m_bAskForFilename)
	{
		CString filename(group->GetFirstFilename());
 		CFileDialog fileDlg(FALSE, // Want to save
							NULL, // Want no default extension
							filename); // Want a default filename

		fileDlg.m_ofn.Flags = fileDlg.m_ofn.Flags & ~OFN_OVERWRITEPROMPT;
		if (fileDlg.DoModal() != IDOK)
			return false;

		// Update group with new info
		group->SetPathname(fileDlg.GetPathName());
		group->SetName(fileDlg.GetFileName());
	}
	else // Assume stuff!
	{
		char buf[1024];
		strcpy(buf,m_pSettings->m_strDefaultDownloadPath);
		if (buf[strlen(buf)] != '\\')
		{
			strcat(buf,"\\");
		}
		strcat(buf,group->GetFirstFilename());
		group->SetPathname(buf);
		group->SetName(group->GetFirstFilename());
	}
	
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// Work done by File manager
/////////////////////////////////////////////////////////////////////////////
void CFilemngrDlg::AddGroup(CDownloadGroup *group)
{
	CString log;
	char buf[100];
	bool bAdd = true;

	if (strlen(group->GetName()) == 0)
	{
		bAdd = UpdateGroupData(group);
	}
	
	int nIdx = FindItem(group); 

	if (nIdx != -1)
	{
		m_ctrlFiles.SetItemData(nIdx,(long)group);
		m_ctrlFiles.SetItemText(nIdx,FM_ACTION,"");
		m_ctrlFiles.SetItemText(nIdx,FM_STATUS,group->GetStatusString());
		m_ctrlFiles.SetItemText(nIdx,FM_SIZE,group->GetFilesizes());
		sprintf(buf, "%d %%",group->GetDone());
		m_ctrlFiles.SetItemText(nIdx,FM_DONE,buf);
	}
	else if (bAdd)
	{
		int nIdx = m_ctrlFiles.InsertItem(m_nNextListIdx,group->GetName(),0);
		m_nNextListIdx++;
		
		m_ctrlFiles.SetItemData(nIdx,(long)group);
		m_ctrlFiles.SetItemText(nIdx,FM_ACTION,"");
		m_ctrlFiles.SetItemText(nIdx,FM_STATUS,group->GetStatusString());
		m_ctrlFiles.SetItemText(nIdx,FM_SIZE,group->GetFilesizes());
		sprintf(buf, "%d %%",group->GetDone());
		m_ctrlFiles.SetItemText(nIdx,FM_DONE,buf);
		log.Format("Added group %s",group->GetName());
	}
	else
	{
		delete group;
		log.Format("Threw away an unnamed group");
	}
	// Some logging

	if (log.GetLength()>0)
		m_pDlgLog->Add(log);

}

void CFilemngrDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CRect rect;
	m_ctrlFiles.GetWindowRect(rect);
	CFileStatus stat;

	if (rect.PtInRect(point)) // it's for the list ctrl
	{
		CMenu popupMenus;
		if (popupMenus.LoadMenu(IDR_POPUP_MENU))
		{
			POSITION pos = m_ctrlFiles.GetFirstSelectedItemPosition();
			CMenu* pPopup;
			if (pos == NULL)
			{
								//pPopup = popupMenus.GetSubMenu(1);
			}
			else
			{
				int nListIdx = m_ctrlFiles.GetNextSelectedItem(pos);
				CDownloadGroup* group = (CDownloadGroup *)m_ctrlFiles.GetItemData(nListIdx);

				BOOL bExists = CFile::GetStatus(group->GetPathname(),stat);

				BOOL bReady = FALSE;
				if (group->GetStatus() == DDS_WAITING ||
					group->GetStatus() == DDS_ABORTED ||
					group->GetStatus() == DDS_COMPLETE)
				{
					bReady = TRUE;
				}
				pPopup = popupMenus.GetSubMenu(0);
				if (!bExists)
					pPopup->EnableMenuItem(ID_POPUP_DELETE_FROMDISK,MF_GRAYED);
				if (!bReady)
					pPopup->EnableMenuItem(ID_POPUP_START,MF_GRAYED);

				pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON,point.x,point.y,this,NULL);	
			}
		}
	}	
}

void CFilemngrDlg::UpdateFromIPC()
{
	CString log;
	log.Format("Fetching new file(s) from main window.");
	m_pDlgLog->Add(log);
	m_fileControl.LoadFromIPC();
	UpdateList();
}

void CFilemngrDlg::UpdateList()
{
	m_fileControl.Rewind();

	CDownloadGroup* group;
	while (group = m_fileControl.GetNext())
	{
		AddGroup(group);
	}
}

void CFilemngrDlg::OnPopupDeleteFromlistonly() 
{
	POSITION pos = m_ctrlFiles.GetFirstSelectedItemPosition();
	while (pos)
	{
		int nListIdx = m_ctrlFiles.GetNextSelectedItem(pos);
		CDownloadGroup* group = (CDownloadGroup *)m_ctrlFiles.GetItemData(nListIdx);
		m_fileControl.DeleteGroup(group);
		m_ctrlFiles.DeleteItem(nListIdx);
		m_ctrlFiles.SetItemState(nListIdx,LVIS_SELECTED,LVIS_SELECTED);
	}
}

void CFilemngrDlg::OnPopupDeleteFromdisk() 
{
	BOOL bDelete = FALSE;
	CFileStatus stat;
	CString log;

	if (m_pSettings->m_bAskBeforeDelete)
	{
		int nRet = MessageBox("Do you really want to delete file(s) from disk too?","Are you sure?",MB_OKCANCEL);
		if (nRet == IDOK)
		{
			bDelete = true;
		}
		log.Format("Almost deleted a group!");
		m_pDlgLog->Add(log);
	}
	else
	{
		bDelete = true;
	}

	if (bDelete)
	{
		POSITION pos = m_ctrlFiles.GetFirstSelectedItemPosition();
		while (pos)
		{
			int nListIdx = m_ctrlFiles.GetNextSelectedItem(pos);
			CDownloadGroup* group = (CDownloadGroup *)m_ctrlFiles.GetItemData(nListIdx);

			if (CFile::GetStatus(group->GetPathname(),stat))
				CFile::Remove(group->GetPathname());

			m_fileControl.DeleteGroup(group);
			m_ctrlFiles.DeleteItem(nListIdx);
			log.Format("Deleted group: %s",group->GetName());
			m_pDlgLog->Add(log);
		}
	}
}

CDownloadGroup* CFilemngrDlg::GetSelectedGroup() 
{
	POSITION pos = m_ctrlFiles.GetFirstSelectedItemPosition();
	if (pos)
	{
		int nListIdx = m_ctrlFiles.GetNextSelectedItem(pos);
		CDownloadGroup* group = (CDownloadGroup *)m_ctrlFiles.GetItemData(nListIdx);
		return group;
	}
	else
		return NULL;
}

BOOL CFilemngrDlg::UpdateGroup(CGroupStatus* status) 
{
	int nIdx = FindItem(status->m_pGroup);
	if (nIdx != -1)
	{
		char strProcent[25];
		sprintf(strProcent,"%d%%",status->m_nProcent);
		
		CDownloadGroup* group = (CDownloadGroup *)m_ctrlFiles.GetItemData(nIdx);
		group->SetDone(status->m_nProcent);
		group->SetStatus(status->m_nStatus);

		m_ctrlFiles.SetItemText(nIdx,FM_STATUS,group->GetStatusString());
		m_ctrlFiles.SetItemText(nIdx,FM_DONE,strProcent);
		
		return TRUE;
	}
	else
		return FALSE;
}

BOOL CFilemngrDlg::UpdateGroup(CDownloadGroup* group) 
{
	int nIdx = FindItem(group);
	if (nIdx != -1)
	{
		m_ctrlFiles.SetItemText(nIdx,FM_NAME,group->GetName());
		return TRUE;
	}
	else
		return FALSE;
}


int CFilemngrDlg::FindItem(CDownloadGroup *group)
{
	LVFINDINFO info;
	info.flags = LVFI_PARAM;
	info.lParam = (LPARAM)group;
	return m_ctrlFiles.FindItem(&info);
}

void CFilemngrDlg::OnFilemngrExecuteEnqueue() 
{
	CDownloadGroup* group = GetSelectedGroup();
	if (group)
		ShellExecute(this->m_hWnd,"enqueue",group->GetPathname(),NULL,NULL,SW_SHOWNOACTIVATE);	
}


void CFilemngrDlg::OnFilemngrEdit() 
{
	CGroupEditDlg dlg;
	CDownloadGroup *group = GetSelectedGroup();
	if (group)
	{
		dlg.SetGroup(group);
		EnableWindow(FALSE);
		int nRet = dlg.DoModal();

		if (nRet == IDOK)
		{
			group->SetName(dlg.m_strGroupName);
			group->SetPathname(dlg.m_strSavePath);			
			UpdateGroup(group);
		}
		EnableWindow(TRUE);
	}
}

void CFilemngrDlg::UpdateQueue(int nDownloadCount, int nMaxDownloads)
{
	int nCount = m_ctrlFiles.GetItemCount();
	int nCanStartCount = nMaxDownloads - nDownloadCount;

	for (int i=0;(i<nCount && nCanStartCount>0);i++)
	{

		CDownloadGroup* group = (CDownloadGroup *)m_ctrlFiles.GetItemData(i);
		if (group->GetStatus() == DDS_WAITING)
		{
			StartDownload(group);
			nCanStartCount--;
		}
	}
}

void CFilemngrDlg::StartDownload(CDownloadGroup *group)
{
	::SendMessage(GetParent()->m_hWnd,WMU_DOWNLOAD_ADD,0,(LPARAM)group);
}
