#if !defined(AFX_FILEMNGRDLG_H__81CA5E94_4496_4040_9CA9_2D2DC27AF748__INCLUDED_)
#define AFX_FILEMNGRDLG_H__81CA5E94_4496_4040_9CA9_2D2DC27AF748__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FilemngrDlg.h : header file
//

#include "ResizableDialog.h"
#include "ControlFile.h"
#include "Settings.h"
#include "LogDlg.h"
#include "GroupStatus.h"

#include <afxtempl.h>

#define FM_NAME 0
#define FM_ACTION 1
#define FM_STATUS 2
#define FM_SIZE 3
#define FM_DONE 4

/////////////////////////////////////////////////////////////////////////////
// CFilemngrDlg dialog

class CFilemngrDlg : public CResizableDialog
{
// Construction
public:
	void StartDownload(CDownloadGroup *group);
	void UpdateQueue(int nDownloadCount, int nMaxDownloads);

	CFilemngrDlg(CWnd* pParent = NULL);   // standard constructor
	BOOL PreTranslateMessage(MSG* pMsg);
		
	void UpdateFromIPC();
	void UpdateList();
	BOOL UpdateGroup(CGroupStatus* status);
	BOOL UpdateGroup(CDownloadGroup* group);

	CDownloadGroup* GetSelectedGroup();
	
	CSettings* m_pSettings;
	CLogDlg* m_pDlgLog;

// Dialog Data
	//{{AFX_DATA(CFilemngrDlg)
	enum { IDD = IDD_FILEMNGR_DIALOG };
	CListCtrl	m_ctrlFiles;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFilemngrDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
	
	
protected:
	// Generated message map functions
	//{{AFX_MSG(CFilemngrDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnPopupDeleteFromlistonly();
	afx_msg void OnPopupDeleteFromdisk();
	afx_msg void OnFilemngrExecuteEnqueue();
	afx_msg void OnFilemngrEdit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	// Private procs
	void AddGroup(CDownloadGroup *group);
	bool UpdateGroupData(CDownloadGroup *group);
	int FindItem(CDownloadGroup *group);

	// Private stuff
	CControlFile m_fileControl;
	int m_nNextListIdx;

	HACCEL m_hAccel;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILEMNGRDLG_H__81CA5E94_4496_4040_9CA9_2D2DC27AF748__INCLUDED_)
