// GroupStatus.cpp: implementation of the CGroupStatus class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GroupStatus.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGroupStatus::CGroupStatus()
{
	m_nType = 0;

	m_nID = -1;
	m_nProcent = 0;		// guess
	m_nStatus = 0;		// see defines in Status.h
	m_dSpeed = 0;		// KB/sec
	m_nHoursLeft = 0;	// ETA in hours
	m_nMinutesLeft = 0;	// ETA in minutes
	m_nSecondsLeft = 0;	// ETA in seconds

	m_strMessage = NULL;

}

CGroupStatus::CGroupStatus(int nID)
{
	CGroupStatus();
	m_nID = nID;
}

CGroupStatus::~CGroupStatus()
{
	FreeData();
}

void CGroupStatus::SetMessage(LPCSTR strMessage)
{
	FreeData();

	m_strMessage = new char[strlen(strMessage)+1];
	strcpy(m_strMessage, strMessage);
}


LPCSTR CGroupStatus::GetMessage()
{
	return m_strMessage;
}

void CGroupStatus::FreeData()
{
	if (m_strMessage)
	{
		delete[] m_strMessage;
		m_strMessage = NULL;
	}
}