// GroupStatus.h: interface for the CGroupStatus class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GROUPSTATUS_H__A880289B_135D_41D0_92CB_70DE6C5B4F99__INCLUDED_)
#define AFX_GROUPSTATUS_H__A880289B_135D_41D0_92CB_70DE6C5B4F99__INCLUDED_

#include "DownloadGroup.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DAV_DOWNLOAD_COMPLETE 0
#define DAV_DOWNLOAD_WAITING 1
#define DAV_DOWNLOAD_DOWNLOADING 2
#define DAV_DOWNLOAD_ABORTED 3
#define DAV_DOWNLOAD_OPENING 4
#define DAV_DOWNLOAD_EXCEPTION 5

#define DGS_MESSAGE			1
#define DGS_STATUSCHANGE	2
#define DGS_DOWNLOADUPDATE	3

class CGroupStatus  
{
private:
	char* m_strMessage;
public:
	int m_nType;		// se defines in GroupStatus.h

	int m_nID;			// zero-based index of downloadthread
	int m_nProcent;		// guess
	int m_nStatus;		// se defines in GroupStatus.h
	double m_dSpeed;	// KB/sec
	int m_nHoursLeft;	// ETA in hours
	int m_nMinutesLeft;	// ETA in minutes
	int m_nSecondsLeft;	// ETA in seconds
	int m_nBytesDownloaded; // Bytes downloaded in this group total
	CDownloadGroup* m_pGroup;
	
	CGroupStatus();
	CGroupStatus(int nID);

	void SetMessage(LPCSTR strMessage);
	LPCSTR GetMessage();
	void FreeData();

	virtual ~CGroupStatus();

};

#endif // !defined(AFX_GROUPSTATUS_H__A880289B_135D_41D0_92CB_70DE6C5B4F99__INCLUDED_)
