// MainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "download.h"
#include "MainDlg.h"
#include "SAPrefsDialog.h"
#include "OptionsPaths.h"
#include "OptionsUI.h"
#include "GroupStatus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

/////////////////////////////////////////////////////////////////////////////
// Constants

// Registered window message
const UINT    wm_Message = 
    RegisterWindowMessage(_T("B52BAD67-B2BD-48b0-B962-101ECF6B919F"));

CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainDlg)
	m_strActiveDownloads = _T("0");
	//}}AFX_DATA_INIT

	// We don't show anything at start
	m_bDownloadDlgVisible = FALSE;
	m_bFilemngrDlgVisible = FALSE;
	m_bLogDlgVisible = FALSE;
}


void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Text(pDX, IDC_MAIN_DOWNLOAD_COUNT, m_strActiveDownloads);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_BN_CLICKED(IDC_MAIN_DOWNLOAD_BUTTON, OnMainDownloadButton)
	ON_WM_MOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_FILE_MANAGER_BUTTON, OnFileManagerButton)
	ON_COMMAND(ID_TRAY_EXIT, OnTrayExit)
	ON_WM_SYSCOMMAND()
	ON_COMMAND(ID_TRAY_RESTORE, OnTrayRestore)
	ON_COMMAND(ID_TRAY_MINIMIZE, OnTrayMinimize)
	ON_BN_CLICKED(IDC_LOG_BUTTON, OnLogButton)
	ON_WM_DESTROY()
	ON_COMMAND(ID_POPUP_START, OnPopupStart)
	ON_MESSAGE(WM_ICON_NOTIFY, OnTrayNotification)
	ON_COMMAND(ID_DOWNLOAD_STOP, OnDownloadStop)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(wm_Message, OnDownloadNotify)
	ON_MESSAGE(WMU_DOWNLOAD, OnDownloadUpdate)
	ON_MESSAGE(WMU_DOWNLOAD_ADD, OnDownloadAdd)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers

int CMainDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_TrayIcon.Create((CWnd *)this, 
							WM_ICON_NOTIFY, 
							"Download Console",
							AfxGetApp()->LoadIcon(IDR_MAINFRAME),
							IDR_TRAY_MENU,FALSE))
		return -1;

	m_hIcon = (HICON)::LoadImage(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR); 
	m_TrayIcon.SetIcon(m_hIcon);

	return 0;
}

BOOL CMainDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Setup icon
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Create other dialogs

	// Log window
	m_dlgLog.m_pSettings = &m_Settings;
	m_dlgLog.Create(IDD_LOG_DIALOG, this);
	m_dlgLog.ModifyStyleEx(WS_EX_APPWINDOW,WS_EX_TOOLWINDOW,0);

	// Download window
	m_dlgDownload.m_pSettings = &m_Settings;
	m_dlgDownload.Create(IDD_DOWNLOAD_DIALOG, this);
	m_dlgDownload.ModifyStyleEx(WS_EX_APPWINDOW,WS_EX_TOOLWINDOW,0);


	// Filemanager window
	m_dlgFilemngr.m_pSettings = &m_Settings;
	m_dlgFilemngr.m_pDlgLog = &m_dlgLog;
	m_dlgFilemngr.Create(IDD_FILEMNGR_DIALOG, this);
	m_dlgFilemngr.ModifyStyleEx(WS_EX_APPWINDOW,WS_EX_TOOLWINDOW,0);

	// Set correct window positions
	CRect rectDesktop;
	CRect rectMain;

	CWnd *pDesktopWnd = GetDesktopWindow();
	pDesktopWnd->GetWindowRect(rectDesktop);
	GetWindowRect(rectMain);
	SetWindowPos(&wndTop, rectDesktop.right - rectMain.right,0,0,0,SWP_NOSIZE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




//////////////////////////////////////////////////////////////////////////////
// Console buttons
//////////////////////////////////////////////////////////////////////////////

void CMainDlg::OnMainDownloadButton() 
{
	if (m_bDownloadDlgVisible)
	{
		m_bDownloadDlgVisible = !m_dlgDownload.ShowWindow(SW_HIDE);

		// move up filemngr
		if (m_bFilemngrDlgVisible)
		{
			CRect rMainDlg;
			CRect rFilemngrDlg;
			GetWindowRect(rMainDlg);	
			m_dlgFilemngr.GetWindowRect(rFilemngrDlg);

			int nx = rMainDlg.left; // frga mig inte.. jag vet inte, men det funkar
			int ny = rMainDlg.bottom;
			
			m_dlgFilemngr.SetWindowPos(&wndTop,nx,ny,rMainDlg.Width(),rFilemngrDlg.Height(),SWP_NOACTIVATE);
		}	
	}
	else
	{
		m_bDownloadDlgVisible = !m_dlgDownload.ShowWindow(SW_SHOWNOACTIVATE);
		CRect rMainDlg;
		CRect rDownloadDlg;
		GetWindowRect(rMainDlg);	
		m_dlgDownload.GetWindowRect(rDownloadDlg);

		int nx = rMainDlg.left; // frga mig inte.. jag vet inte, men det funkar
		int ny = rMainDlg.bottom;
		m_dlgDownload.SetWindowPos(&wndTop,nx,ny,rMainDlg.Width(),rDownloadDlg.Height(),SWP_NOACTIVATE);

		// Bump down filemngr 
		if (m_bFilemngrDlgVisible)
		{
			ny += rDownloadDlg.Height();
			m_dlgFilemngr.SetWindowPos(&wndTop,nx,ny,0,0,SWP_NOSIZE);
		}	
	}		
}


void CMainDlg::OnFileManagerButton() 
{
	if (m_bFilemngrDlgVisible)
	{
		m_bFilemngrDlgVisible = !m_dlgFilemngr.ShowWindow(SW_HIDE);
	}
	else
	{
		m_bFilemngrDlgVisible = !m_dlgFilemngr.ShowWindow(SW_SHOWNOACTIVATE);
		CRect rMainDlg;
		CRect rFilemngrDlg;
		GetWindowRect(rMainDlg);	
		m_dlgFilemngr.GetWindowRect(rFilemngrDlg);

		int nx = rMainDlg.left; // frga mig inte.. jag vet inte, men det funkar
		int ny = rMainDlg.bottom;
		
		if (m_bDownloadDlgVisible)
		{
			CRect rDownloadDlg;
			m_dlgDownload.GetWindowRect(rDownloadDlg);
			ny += rDownloadDlg.Height();		
		}
		m_dlgFilemngr.SetWindowPos(&wndTop,nx,ny,rMainDlg.Width(),rFilemngrDlg.Height(),SWP_NOACTIVATE);
	}			
}

void CMainDlg::OnLogButton() 
{
	if (m_bLogDlgVisible)
	{
		m_bLogDlgVisible = !m_dlgLog.ShowWindow(SW_HIDE);
	}
	else
	{
		m_bLogDlgVisible = !m_dlgLog.ShowWindow(SW_SHOWNOACTIVATE);
		CRect rMainDlg;
		CRect rLogDlg;

		GetWindowRect(rMainDlg);
		m_dlgLog.GetWindowRect(rLogDlg);

		int nx = rMainDlg.left - rLogDlg.Width(); // frga mig inte.. jag vet inte, men det funkar
		int ny = rMainDlg.top;

		m_dlgLog.SetWindowPos(&wndTop,nx,ny,0,0,SWP_NOACTIVATE|SWP_NOSIZE);		
	}	
}

//////////////////////////////////////////////////////////////////////////////
// Make movable with mouse in whole window
//////////////////////////////////////////////////////////////////////////////

void CMainDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);
	PostMessage( WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM( point.x, point.y));	
}

//////////////////////////////////////////////////////////////////////////////
// Systray messages
//////////////////////////////////////////////////////////////////////////////

LRESULT CMainDlg::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
	return m_TrayIcon.OnTrayNotification(wParam, lParam);
}

void CMainDlg::OnTrayExit() 
{
	OnOK();	
}

void CMainDlg::OnTrayRestore() 
{
	if (m_bFilemngrDlgVisible)
		m_dlgFilemngr.ShowWindow(SW_SHOW);

	if (m_bDownloadDlgVisible)
		m_dlgDownload.ShowWindow(SW_SHOW);

	if (m_bLogDlgVisible)
		m_dlgLog.ShowWindow(SW_SHOW);

	CSystemTray::MaximiseFromTray(this);
}

void CMainDlg::OnTrayMinimize() 
{
	CSystemTray::MinimiseToTray(this);	
	m_dlgFilemngr.ShowWindow(SW_HIDE);
	m_dlgDownload.ShowWindow(SW_HIDE);
	m_dlgLog.ShowWindow(SW_HIDE);
	/*m_bFilemngrDlgVisible = false;
	m_bDownloadDlgVisible = false;
	m_bLogDlgVisible = false;*/
}


//////////////////////////////////////////////////////////////////////////////
// System commands
//////////////////////////////////////////////////////////////////////////////

void CMainDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);

	CRect rMainDlg;
	GetWindowRect(rMainDlg);	

	int nx = x - 3; // frga mig inte.. jag vet inte, men det funkar
	int ny = rMainDlg.bottom;


	if (m_bDownloadDlgVisible)
	{
		CRect rDownloadDlg;
		m_dlgDownload.SetWindowPos(&wndTop,nx,ny,0,0,SWP_NOSIZE);
		m_dlgDownload.GetWindowRect(rDownloadDlg);
		ny += rDownloadDlg.Height();
	}

	if (m_bFilemngrDlgVisible)
	{
		m_dlgFilemngr.SetWindowPos(&wndTop,nx,ny,0,0,SWP_NOSIZE);
	}

	if (m_bLogDlgVisible)
	{
		CRect rect;
		m_dlgLog.GetWindowRect(rect);
		m_dlgLog.SetWindowPos(&wndTop,nx-rect.Width(),rMainDlg.top,0,0,SWP_NOSIZE);
	}


}

void CMainDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	switch (nID)
	{
	case SC_CLOSE:
		if (BeforeClose())
		{
			CDialog::OnSysCommand(nID, lParam);			
		}
		break;
	case SC_MINIMIZE:
		//ModifyStyle(WS_VISIBLE,0);
		//SetParent(GetParent());
		//UpdateWindow();
		OnTrayMinimize();
		//CDialog::OnSysCommand(nID, lParam);
		//ShowWindow(SW_HIDE);
		break;
	default:
		CDialog::OnSysCommand(nID, lParam);
		break;
	}	
}

void CMainDlg::OnDestroy() 
{
	while (!m_listDownloads.IsEmpty())
	{
		CDownloadThread* download = m_listDownloads.RemoveHead();
		if (!download->IsRunning())
			delete download;
		else
		{
			download->Stop();
			delete download;
		}
	}
	
	CDialog::OnDestroy();
	m_dlgDownload.DestroyWindow();
}

LRESULT CMainDlg::OnDownloadNotify(WPARAM wParam, LPARAM lParam)
{
	TRACE("CMainDlg: Got update message from main app.\n");
	m_dlgFilemngr.UpdateFromIPC();
	m_dlgFilemngr.UpdateQueue(m_Status.m_nActiveDownloads,m_Settings.m_nMaxDownloadCount);
	return 0;
}

void CMainDlg::OnPopupStart() 
{
	// Get Downloadgroup
	CDownloadGroup *group = m_dlgFilemngr.GetSelectedGroup();

	if (group)
	{
		// Add to downloadDlg.m_ctrlDownloadList
		m_dlgDownload.AddGroup(group);
			
			// Create new download
		CDownloadThread* newDownload = new CDownloadThread(group);
	
		// Set up parent of download
		newDownload->m_pParentWnd = this->m_hWnd;
		
		// Add it to list of downloads
		m_listDownloads.AddTail(newDownload);
	
		// Start it,
		newDownload->Start();
		m_Status.m_nActiveDownloads++;
		m_strActiveDownloads.Format("%d",m_Status.m_nActiveDownloads);
		UpdateData(FALSE);
	}
}

LRESULT CMainDlg::OnDownloadUpdate(WPARAM wParam, LPARAM lParam)
{
	CString log;
	CString tmp;
	if (wParam == DAV_DOWNLOAD_UPDATE)
	{
		CGroupStatus* status = (CGroupStatus *)lParam;

		switch (status->m_nType)
		{
		case DGS_MESSAGE:		
			m_dlgLog.Add(status);
			break;

		case DGS_STATUSCHANGE:
			TRACE("Status change: %d\n",status->m_nStatus);
			m_dlgFilemngr.UpdateGroup(status);

			if (status->m_nStatus == DDS_COMPLETE || status->m_nStatus == DDS_ABORTED)
			{
				m_dlgDownload.RemoveGroup(status);

				m_Status.m_nActiveDownloads--;
				m_strActiveDownloads.Format("%d",m_Status.m_nActiveDownloads);
				UpdateData(FALSE);

				m_dlgFilemngr.UpdateQueue(m_Status.m_nActiveDownloads,m_Settings.m_nMaxDownloadCount);
			}
			else
			{
				m_dlgDownload.UpdateGroup(status);
			}

			break;

		case DGS_DOWNLOADUPDATE:
			m_dlgDownload.UpdateGroup(status);
			m_dlgFilemngr.UpdateGroup(status);
			break;
		}
	}
	return 0;
}

BOOL CMainDlg::BeforeClose()
{
	if (m_Status.m_nActiveDownloads > 0)
	{
		int nRet = MessageBox("You have active downloads! Do you wish to exit anyway?","Warning!",MB_OKCANCEL);
		if (nRet == IDOK)
		{
			StopDownloads();
			return TRUE;
		}
		else
			return FALSE;
	}
	else
		return TRUE;
}

BOOL CMainDlg::StopDownloads()
{
	POSITION pos =  m_listDownloads.GetHeadPosition();
	while (pos)
	{
		CDownloadThread* thread = m_listDownloads.GetNext(pos);
		thread->Stop();
		CDownloadGroup *group = thread->GetGroup();
		// Have to do this manually
		if (group->GetStatus() == DDS_DOWNLOADING)
		{
			group->SetStatus(DDS_ABORTED);
		}
	}
	return TRUE;
}

BOOL CMainDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
	return CDialog::PreCreateWindow(cs);
}

void CMainDlg::OnDownloadStop() 
{
	CDownloadGroup *group = m_dlgDownload.GetSelectedGroup();	
	
	POSITION pos =  m_listDownloads.GetHeadPosition();
	while (pos)
	{
		CDownloadThread* thread = m_listDownloads.GetNext(pos);
		
		if (thread->GetGroup() == group)
			thread->Abort();
	}

	
}

LRESULT CMainDlg::OnDownloadAdd(WPARAM wParam, LPARAM lParam)
{
	// Get Downloadgroup
	CDownloadGroup *group = (CDownloadGroup*)lParam;

	if (group)
	{
		// Add to downloadDlg.m_ctrlDownloadList
		m_dlgDownload.AddGroup(group);
			
			// Create new download
		CDownloadThread* newDownload = new CDownloadThread(group);
	
		// Set up parent of download
		newDownload->m_pParentWnd = this->m_hWnd;
		
		// Add it to list of downloads
		m_listDownloads.AddTail(newDownload);
	
		// Start it,
		newDownload->Start();
		m_Status.m_nActiveDownloads++;
		m_strActiveDownloads.Format("%d",m_Status.m_nActiveDownloads);
		UpdateData(FALSE);
	}
	return 0;
}
